#ifndef KALMAN_VARIO_H_
#define KALMAN_VARIO_H_



class KalmanVario {
public :
KalmanVario(){};
void Config(float zVariance, float zAccelVariance, float zAccelBiasVariance, float zInitial, float vInitial, float aBiasInitial);
void Update(float z, float a, float dt, float* pZ, float* pV);
void Update(float z, float a, float dt);

  /* at any time get result */
double getPosition();
double getCalibratedPosition();
double getVelocity();
double getAcceleration();
unsigned long getTimestamp();

  /* reset the current position without changing velocity and acceleration */
void calibratePosition(double newPosition);


private :
// State being tracked
float z_;  // position
float v_;  // velocity
float aBias_;  // acceleration

unsigned long t;

  /* calibration */
double calibrationDrift;

// 3x3 State Covariance matrix
float Pzz_;
float Pzv_;
float Pza_;
float Pvz_;
float Pvv_;
float Pva_;
float Paz_;
float Pav_;
float Paa_;
float zAccelBiasVariance_; // assumed fixed.
float zAccelVariance_;  // dynamic acceleration variance
float zVariance_; //  z measurement noise variance fixed

};

#endif

